#version 430

layout (points) in; // points in
layout (triangle_strip) out; 
layout (max_vertices = 4) out;

layout(location = 1) uniform mat4 projectionMatrix;
layout(location = 2) uniform float particle_size;
layout(location = 3) uniform float TTL0;



in vData
{
	float TTL1;
} vertex[];


out vec2 Vertex_UV;
out vec4 Vertex_Color;

void main (void)
{
  vec4 P = gl_in[0].gl_Position;

  // a: left-bottom
  vec2 va = P.xy + vec2(-0.5, -0.5) * particle_size * (TTL0-vertex[0].TTL1);
  gl_Position = projectionMatrix * vec4(va, P.zw);
  Vertex_UV = vec2(0.0, 0.0);
  Vertex_Color = vec4(1.0f, 1.0f, 1.0f, vertex[0].TTL1/TTL0);
  EmitVertex();
    
  // d: right-bottom
  vec2 vd = P.xy + vec2(0.5, -0.5) * particle_size * (TTL0-vertex[0].TTL1);
  gl_Position = projectionMatrix * vec4(vd, P.zw);
  Vertex_UV = vec2(1.0, 0.0);
  Vertex_Color = vec4(1.0f, 1.0f, 1.0f, vertex[0].TTL1/TTL0);
  EmitVertex();

   // b: left-top
  vec2 vb = P.xy + vec2(-0.5, 0.5) * particle_size * (TTL0-vertex[0].TTL1);
  gl_Position = projectionMatrix * vec4(vb, P.zw);
  Vertex_UV = vec2(0.0, 1.0);
  Vertex_Color = vec4(1.0f, 1.0f, 1.0f, vertex[0].TTL1/TTL0);
  EmitVertex();

  // c: right-top
  vec2 vc = P.xy + vec2(0.5, 0.5) * particle_size * (TTL0-vertex[0].TTL1);
  gl_Position = projectionMatrix * vec4(vc, P.zw);
  Vertex_UV = vec2(1.0, 1.0);
  Vertex_Color = vec4(1.0f, 1.0f, 1.0f, vertex[0].TTL1/TTL0);
  EmitVertex();
  
  EndPrimitive();
}