#version 430 core
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;

out VertexData {
	vec3 position_world;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform float offset;

void main() {

	//offset position along normal direction to create silhouette
	vec4 position_world_ = modelMatrix * vec4((position + (normal * offset)), 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}